include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern

pSource equ ZW0
pVram equ ZW0
count equ ZB0
VramH equ ZB1


cseg
CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts
; VdpValues:
;     defb $02, $e2
;     defb Vram_PatternName shr 10
;     defb (Vram_Color shr 6) or $7f
;     defb (Vram_PatternGenerator shr 11) or $03
;     defb Vram_SpriteAttribute shr 7
;     defb Vram_SpriteGenerator shr 11
;     defb $00
ColorSource:
defb 64, $f0 ; Ascii
defb 16, $70 ; Logo
defb 2, $60 ; Wall
defb 1, $e0 ; HardWall
defb 2, $a0 ; Meter
defb 12, $f0 ; MyFort
defb 12, $30 ; EnemyFort
defb 0
cseg
InitVram: public InitVram
    sei
        ; ldy #$80
        ; ldx #0
        ; do
        ;     lda VdpValues,x | inx
        ;     sta VdpWritePort+1
        ;     tya | sta VdpWritePort+1
        ;     iny
        ;     cpx #8
        ; while ne | wend
            
        lda #0 | sta <VramH
        do
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #$40 or high Vram_PatternGenerator | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_End
            jsr CopyToVdp

            lda #low Vram_Color | sta VdpWritePort+1
            lda #$40 or high Vram_Color | ora <VramH | sta VdpWritePort+1
            ldx #0
            do
                lda ColorSource,x
            while ne
                sta <count
                inx
                lda ColorSource,x | inx
                do
                    ldy #8
                    do
                        sta VdpWritePort
                        jsr WaitVdp
                        dey
                    while ne | wend
                    dec <count
                while ne | wend
            wend
            
            lda <VramH | clc|adc #8 | sta <VramH
            cmp #8*3
        while ne | wend
    cli
    WaitVdp: public WaitVdp
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            lda #low Vram_PatternName | sta VdpWritePort+1
            lda #$40 or high Vram_PatternName | sta VdpWritePort+1
            lda #Char_Space
            ldy #VramHeight
            do
                ldx #VramWidth
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                dey
            while ne | wend
        cli
    pla
rts


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda #0 | sta <pVram+1
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        asl	a | rol <pVram+1 ; *8
        asl	a | rol <pVram+1 ; *16
        asl	a | rol <pVram+1 ; *32

        clc|adc VramAddress_.x_ | tay
        lda <pVram+1 | adc #0 | tax

        tya clc|adc #low Vram | tay
        txa adc #high Vram | tax
	pla
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        sei
            lda Put_pVram | sta VdpWritePort+1
            lda Put_pVram+1 | ora #$40 | sta VdpWritePort+1
            lda Put_c
            sta VdpWritePort
        cli
        lda Put_pVram | clc|adc #1 | tay
        lda Put_pVram+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram:
    defw 0
PrintC_@Param1: public PrintC_@Param1
PrintC_c:
    defb 0
cseg
PrintC_: public PrintC_
    pha
        sei
            lda PrintC_pVram | sta VdpWritePort+1
            lda PrintC_pVram+1 | ora #$40 | sta VdpWritePort+1
            lda PrintC_c
            sec|sbc #$20
            sta VdpWritePort
        cli
        lda PrintC_pVram | clc|adc #1 | tay
        lda PrintC_pVram+1 | adc #0 | tax
    pla
rts
